Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1584)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1585)
@@ -143,45 +342,249 @@
     SUBROUTINE init_radiation
     
-
        IMPLICIT NONE
 
-       ALLOCATE ( alpha(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rad_net(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rad_lw_in(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rad_lw_out(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rad_sw_in(nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rad_sw_out(nysg:nyng,nxlg:nxrg) )
-
-       rad_sw_in  = 0.0_wp
-       rad_sw_out = 0.0_wp
-       rad_lw_in  = 0.0_wp
-       rad_lw_out = 0.0_wp
-       rad_net    = 0.0_wp
-
-       alpha = albedo
+!
+!--    Allocate array for storing the surface net radiation
+       IF ( .NOT. ALLOCATED ( rad_net ) )  THEN
+          ALLOCATE ( rad_net(nysg:nyng,nxlg:nxrg) )
+          rad_net = 0.0_wp
+       ENDIF
 
 !
 !--    Fix net radiation in case of radiation_scheme = 'constant'
-       IF ( irad_scheme == 0 )  THEN
+       IF ( radiation_scheme == 'constant' )  THEN
           rad_net = net_radiation
-!
-!--    Calculate radiation scheme constants
-       ELSEIF ( irad_scheme == 1 .OR. irad_scheme == 2 )  THEN
+          radiation = .FALSE.
+!
+!--    Calculate orbital constants
+       ELSE
           decl_1 = SIN(23.45_wp * pi / 180.0_wp)
           decl_2 = 2.0_wp * pi / 365.0_wp
           decl_3 = decl_2 * 81.0_wp
-!
-!--       Calculate latitude and longitude angles (lat and lon, respectively)
-          lat = phi * pi / 180.0_wp
-          lon = lambda * pi / 180.0_wp
+          lat    = phi * pi / 180.0_wp
+          lon    = lambda * pi / 180.0_wp
        ENDIF
+
+
+       IF ( radiation_scheme == 'clear-sky' )  THEN
+
+          ALLOCATE ( alpha(nysg:nyng,nxlg:nxrg) )
+
+          IF ( .NOT. ALLOCATED ( rad_sw_in ) )  THEN
+             ALLOCATE ( rad_sw_in(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          IF ( .NOT. ALLOCATED ( rad_sw_out ) )  THEN
+             ALLOCATE ( rad_sw_out(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_in_av ) )  THEN
+             ALLOCATE ( rad_sw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          IF ( .NOT. ALLOCATED ( rad_sw_out_av ) )  THEN
+             ALLOCATE ( rad_sw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_in ) )  THEN
+             ALLOCATE ( rad_lw_in(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          IF ( .NOT. ALLOCATED ( rad_lw_out ) )  THEN
+             ALLOCATE ( rad_lw_out(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_in_av ) )  THEN
+             ALLOCATE ( rad_lw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          IF ( .NOT. ALLOCATED ( rad_lw_out_av ) )  THEN
+             ALLOCATE ( rad_lw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          rad_sw_in  = 0.0_wp
+          rad_sw_out = 0.0_wp
+          rad_lw_in  = 0.0_wp
+          rad_lw_out = 0.0_wp
+
+!
+!--       Overwrite albedo if manually set in parameter file
+          IF ( albedo_type /= 0 .AND. albedo == 9999999.9_wp )  THEN
+             albedo = albedo_pars(2,albedo_type)
+          ENDIF
+    
+          alpha = albedo
+  
+!
+!--    Initialization actions for RRTMG
+       ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
+#if defined ( __rrtmg )
+!
+!--       Allocate albedos
+          ALLOCATE ( rrtm_aldif(0:0,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rrtm_aldir(0:0,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rrtm_asdif(0:0,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rrtm_asdir(0:0,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( aldif(nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( aldir(nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( asdif(nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( asdir(nysg:nyng,nxlg:nxrg) )
+
+          IF ( albedo_type /= 0 )  THEN
+             IF ( albedo_lw_dif == 9999999.9_wp )  THEN
+                albedo_lw_dif = albedo_pars(0,albedo_type)
+                albedo_lw_dir = albedo_lw_dif
+             ENDIF
+             IF ( albedo_sw_dif == 9999999.9_wp )  THEN
+                albedo_sw_dif = albedo_pars(1,albedo_type)
+                albedo_sw_dir = albedo_sw_dif
+             ENDIF
+          ENDIF
+
+          aldif(:,:) = albedo_lw_dif
+          aldir(:,:) = albedo_lw_dir
+          asdif(:,:) = albedo_sw_dif
+          asdir(:,:) = albedo_sw_dir
+!
+!--       Calculate initial values of current (cosine of) the zenith angle and 
+!--       whether the sun is up
+          CALL calc_zenith     
+!
+!--       Calculate initial surface albedo
+          IF ( .NOT. constant_albedo )  THEN
+             CALL calc_albedo
+          ELSE
+             rrtm_aldif(0,:,:) = aldif(:,:)
+             rrtm_aldir(0,:,:) = aldir(:,:)
+             rrtm_asdif(0,:,:) = asdif(:,:) 
+             rrtm_asdir(0,:,:) = asdir(:,:)   
+          ENDIF
+
+!
+!--       Allocate surface emissivity
+          ALLOCATE ( rrtm_emis(0:0,1:nbndlw+1) )
+          rrtm_emis = emissivity
+
+!
+!--       Allocate 3d arrays of radiative fluxes and heating rates
+          ALLOCATE ( rad_sw_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_sw_cs_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_sw_cs_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_sw_cs_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+
+          IF ( .NOT. ALLOCATED ( rad_sw_in ) )  THEN
+             ALLOCATE ( rad_sw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_in = 0.0_wp
+
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_in_av ) )  THEN
+             ALLOCATE ( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_out = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_out ) )  THEN
+             ALLOCATE ( rad_sw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_out_av ) )  THEN
+             ALLOCATE ( rad_sw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          ALLOCATE ( rad_lw_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_lw_cs_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_lw_cs_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_lw_cs_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+
+          IF ( .NOT. ALLOCATED ( rad_lw_in ) )  THEN
+             ALLOCATE ( rad_lw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_lw_in     = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_in_av ) )  THEN
+             ALLOCATE ( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_out ) )  THEN
+             ALLOCATE ( rad_lw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+            rad_lw_out    = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_out_av ) )  THEN
+             ALLOCATE ( rad_lw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ENDIF
+
+          rad_sw_hr     = 0.0_wp
+          rad_sw_cs_in  = 0.0_wp
+          rad_sw_cs_out = 0.0_wp
+          rad_sw_cs_hr  = 0.0_wp
+
+          rad_lw_hr     = 0.0_wp
+          rad_lw_cs_in  = 0.0_wp
+          rad_lw_cs_out = 0.0_wp
+          rad_lw_cs_hr  = 0.0_wp
+
+!
+!--       Allocate dummy array for storing surface temperature
+          ALLOCATE ( rrtm_tsfc(1) )
+
+!
+!--       Initialize RRTMG
+          IF ( lw_radiation )  CALL rrtmg_lw_ini ( cp )
+          IF ( sw_radiation )  CALL rrtmg_sw_ini ( cp )
+
+!
+!--       Set input files for RRTMG
+          INQUIRE(FILE="RAD_SND_DATA", EXIST=snd_exists) 
+          IF ( .NOT. snd_exists )  THEN
+             rrtm_input_file = "rrtmg_lw.nc"
+          ENDIF
+
+!
+!--       Read vertical layers for RRTMG from sounding data
+!--       The routine provides nzt_rad, hyp_snd(1:nzt_rad),
+!--       t_snd(nzt+2:nzt_rad), rrtm_play(1:nzt_rad), rrtm_plev(1_nzt_rad+1), 
+!--       rrtm_tlay(nzt+2:nzt_rad), rrtm_tlev(nzt+2:nzt_rad+1)
+          CALL read_sounding_data
+
+!
+!--       Read trace gas profiles from file. This routine provides
+!--       the rrtm_ arrays (1:nzt_rad+1)
+          CALL read_trace_gas_data
+#endif
+       ENDIF
+
+!
+!--    Perform user actions if required
+       CALL user_init_radiation
+
+
 !
 !--    Add timeseries for radiation model
+       dots_rad = dots_num + 1
        dots_label(dots_num+1) = "rad_net"
-       dots_label(dots_num+2) = "rad_sw_in"
-       dots_unit(dots_num+1:dots_num+2) = "W/m2"
-
-       dots_rad  = dots_num + 1
-       dots_num  = dots_num + 2
+       dots_label(dots_num+2) = "rad_lw_in"
+       dots_label(dots_num+3) = "rad_lw_out"
+       dots_label(dots_num+4) = "rad_sw_in"
+       dots_label(dots_num+5) = "rad_sw_out"
+       dots_unit(dots_num+1:dots_num+5) = "W/m2"
+       dots_num  = dots_num + 5
+
+!
+!--    Output of albedos is only required for RRTMG
+       IF ( radiation_scheme == 'rrtmg' )  THEN
+          dots_label(dots_num+1) = "rrtm_aldif"
+          dots_label(dots_num+2) = "rrtm_aldir"
+          dots_label(dots_num+3) = "rrtm_asdif"
+          dots_label(dots_num+4) = "rrtm_asdir"
+          dots_unit(dots_num+1:dots_num+4) = ""
+          dots_num  = dots_num + 4
+       ENDIF
+
+!
+!--    Calculate radiative fluxes at model start
+       IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+          IF ( radiation_scheme == 'clear-sky' )  THEN
+              CALL radiation_clearsky
+          ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
+             CALL radiation_rrtmg
+          ENDIF
+       ENDIF
 
        RETURN
@@ -196,13 +599,267 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE radiation_clearsky
-    
+
+       USE indices,                                                            &
+           ONLY:  nbgp
 
        IMPLICIT NONE
 
+       INTEGER(iwp) :: i, j, k
+
+!
+!--    Calculate current zenith angle
+       CALL calc_zenith
+
+!
+!--    Calculate sky transmissivity
+       sky_trans = 0.6_wp + 0.2_wp * zenith(0)
+
+!
+!--    Calculate value of the Exner function
+       exn = (surface_pressure / 1000.0_wp )**0.286_wp
+!
+!--    Calculate radiation fluxes and net radiation (rad_net) for each grid 
+!--    point
+       DO i = nxl, nxr
+          DO j = nys, nyn
+             k = nzb_s_inner(j,i)
+             rad_sw_in(0,j,i)  = solar_constant * sky_trans * zenith(0)
+             rad_sw_out(0,j,i) = alpha(j,i) * rad_sw_in(0,j,i)
+             rad_lw_out(0,j,i) = sigma_sb * (pt(k,j,i) * exn)**4
+             rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt(k+1,j,i) * exn)**4
+             rad_net(j,i)      = rad_sw_in(0,j,i) - rad_sw_out(0,j,i)          &
+                                 + rad_lw_in(0,j,i) - rad_lw_out(0,j,i)
+
+          ENDDO
+       ENDDO
+
+       CALL exchange_horiz_2d( rad_lw_in,  nbgp )
+       CALL exchange_horiz_2d( rad_lw_out, nbgp )
+       CALL exchange_horiz_2d( rad_sw_in,  nbgp )
+       CALL exchange_horiz_2d( rad_sw_out, nbgp )
+       CALL exchange_horiz_2d( rad_net,    nbgp )
+
+       RETURN
+
+    END SUBROUTINE radiation_clearsky
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!-- Implementation of the RRTMG radiation_scheme
+!------------------------------------------------------------------------------!
+    SUBROUTINE radiation_rrtmg
+
+       USE indices,                                                            &
+           ONLY:  nbgp
+
+       USE particle_attributes,                                                &
+           ONLY:  grid_particles, number_of_particles, particles,              &
+                  particle_advection_start, prt_count
+
+       IMPLICIT NONE
+
+#if defined ( __rrtmg )
+
+       INTEGER(iwp) :: i, j, k, n          !: 
+
+       REAL(wp)     ::  s_r2      !: weighted sum over all droplets with r^2
+       REAL(wp)     ::  s_r3      !: weighted sum over all droplets with r^3
+
+!
+!--    Calculate current (cosine of) zenith angle and whether the sun is up
+       CALL calc_zenith     
+!
+!--    Calculate surface albedo
+       IF ( .NOT. constant_albedo )  THEN
+          CALL calc_albedo
+       ENDIF
+
+!
+!--    Prepare input data for RRTMG
+
+!
+!--    In case of large scale forcing with surface data, calculate new pressure
+!--    profile. nzt_rad might be modified by these calls and all required arrays
+!--    will then be re-allocated
+       IF ( large_scale_forcing  .AND.  lsf_surf ) THEN
+          CALL read_sounding_data
+          CALL read_trace_gas_data
+       ENDIF
+!
+!--    Loop over all grid points
+       DO i = nxl, nxr
+          DO j = nys, nyn
+
+!
+!--          Prepare profiles of temperature and H2O volume mixing ratio
+             rrtm_tlev(0,nzb+1) = pt(nzb,j,i)
+
+             DO k = nzb+1, nzt+1
+                rrtm_tlay(0,k) = pt(k,j,i) * ( (hyp(k) ) / 100000.0_wp         &
+                                 )**0.286_wp + ( l_v / cp ) * ql(k,j,i)
+                rrtm_h2ovmr(0,k) = mol_weight_air_d_wv * (q(k,j,i) - ql(k,j,i))
+
+             ENDDO
+
+!
+!--          Avoid temperature/humidity jumps at the top of the LES domain by 
+!--          linear interpolation from nzt+2 to nzt+7
+             DO k = nzt+2, nzt+7
+                rrtm_tlay(0,k) = rrtm_tlay(0,nzt+1)                            &
+                              + ( rrtm_tlay(0,nzt+8) - rrtm_tlay(0,nzt+1) )    &
+                              / ( rrtm_play(0,nzt+8) - rrtm_play(0,nzt+1) )    &
+                              * ( rrtm_play(0,k) - rrtm_play(0,nzt+1) )
+
+                rrtm_h2ovmr(0,k) = rrtm_h2ovmr(0,nzt+1)                        &
+                              + ( rrtm_h2ovmr(0,nzt+8) - rrtm_h2ovmr(0,nzt+1) )&
+                              / ( rrtm_play(0,nzt+8)   - rrtm_play(0,nzt+1)   )&
+                              * ( rrtm_play(0,k) - rrtm_play(0,nzt+1) )
+
+             ENDDO
+
+!--          Linear interpolate to zw grid
+             DO k = nzb+2, nzt+8
+                rrtm_tlev(0,k)   = rrtm_tlay(0,k-1) + (rrtm_tlay(0,k) -        &
+                                   rrtm_tlay(0,k-1))                           &
+                                   / ( rrtm_play(0,k) - rrtm_play(0,k-1) )     &
+                                   * ( rrtm_plev(0,k) - rrtm_play(0,k-1) )
+             ENDDO
+
+
+!
+!--          Calculate liquid water path and cloud fraction for each column.
+!--          Note that LWP is required in g/mÂ² instead of kg/kg m.
+             rrtm_cldfr  = 0.0_wp
+             rrtm_reliq  = 0.0_wp
+             rrtm_cliqwp = 0.0_wp
+
+             DO k = nzb+1, nzt+1
+                rrtm_cliqwp(0,k) =  ql(k,j,i) * 1000.0_wp *                      &
+                                  (rrtm_plev(0,k) - rrtm_plev(0,k+1)) * 100.0_wp / g 
+
+                IF ( rrtm_cliqwp(0,k) .GT. 0 )  THEN
+                   rrtm_cldfr(0,k) = 1.0_wp
+                   rrtm_icld = 1
+
+!
+!--                Calculate cloud droplet effective radius
+                   IF ( cloud_physics )  THEN
+                      rrtm_reliq(0,k) = 1.0E6_wp * ( 3.0_wp * ql(k,j,i)          &
+                                      / ( 4.0_wp * pi * nc_const * rho_l )     &
+                                      )**0.33333333333333_wp                   &
+                                     * EXP( LOG( sigma_gc )**2 )
+
+                   ELSEIF ( cloud_droplets )  THEN
+                      number_of_particles = prt_count(k,j,i)
+
+                      IF (number_of_particles <= 0)  CYCLE
+                      particles => grid_particles(k,j,i)%particles(1:number_of_particles)
+                      s_r2 = 0.0_wp
+                      s_r3 = 0.0_wp
+
+                      DO  n = 1, number_of_particles
+                         IF ( particles(n)%particle_mask )  THEN
+                            s_r2 = s_r2 + particles(n)%radius**2 * &
+                                   particles(n)%weight_factor
+                            s_r3 = s_r3 + particles(n)%radius**3 * &
+                                   particles(n)%weight_factor
+                         ENDIF
+                      ENDDO
+
+                      IF ( s_r2 > 0.0_wp )  rrtm_reliq(0,k) = s_r3 / s_r2
+
+                   ENDIF
+
+!
+!--                Limit effective radius
+                   IF ( rrtm_reliq(0,k) .GT. 0.0_wp )  THEN
+                      rrtm_reliq(0,k) = MAX(rrtm_reliq(0,k),2.5_wp)
+                      rrtm_reliq(0,k) = MIN(rrtm_reliq(0,k),60.0_wp)
+                  ENDIF
+                ELSE
+                   rrtm_icld = 0
+                ENDIF
+             ENDDO
+
+!
+!--          Set surface temperature
+             rrtm_tsfc = pt(nzb,j,i) * (surface_pressure / 1000.0_wp )**0.286_wp
+
+             IF ( lw_radiation )  THEN
+               CALL rrtmg_lw( 1, nzt_rad      , rrtm_icld    , rrtm_idrv      ,&
+               rrtm_play       , rrtm_plev    , rrtm_tlay    , rrtm_tlev      ,&
+               rrtm_tsfc       , rrtm_h2ovmr  , rrtm_o3vmr   , rrtm_co2vmr    ,&
+               rrtm_ch4vmr     , rrtm_n2ovmr  , rrtm_o2vmr   , rrtm_cfc11vmr  ,&
+               rrtm_cfc12vmr   , rrtm_cfc22vmr, rrtm_ccl4vmr , rrtm_emis      ,&
+               rrtm_inflglw    , rrtm_iceflglw, rrtm_liqflglw, rrtm_cldfr     ,&
+               rrtm_lw_taucld  , rrtm_cicewp  , rrtm_cliqwp  , rrtm_reice     ,& 
+               rrtm_reliq      , rrtm_lw_tauaer,                               &
+               rrtm_lwuflx     , rrtm_lwdflx  , rrtm_lwhr  ,                   &
+               rrtm_lwuflxc    , rrtm_lwdflxc , rrtm_lwhrc )
+
+                DO k = nzb, nzt+1
+                   rad_lw_in(k,j,i)  = rrtm_lwdflx(0,k)
+                   rad_lw_out(k,j,i) = rrtm_lwuflx(0,k)
+                ENDDO
+
+
+             ENDIF
+
+             IF ( sw_radiation .AND. sun_up )  THEN
+                CALL rrtmg_sw( 1, nzt_rad      , rrtm_icld  , rrtm_iaer       ,&
+               rrtm_play       , rrtm_plev    , rrtm_tlay  , rrtm_tlev        ,&
+               rrtm_tsfc       , rrtm_h2ovmr  , rrtm_o3vmr , rrtm_co2vmr      ,&
+               rrtm_ch4vmr     , rrtm_n2ovmr  , rrtm_o2vmr , rrtm_asdir(:,j,i),&
+               rrtm_asdif(:,j,i), rrtm_aldir(:,j,i), rrtm_aldif(:,j,i), zenith,&
+               0.0_wp          , day          , solar_constant,   rrtm_inflgsw,&
+               rrtm_iceflgsw   , rrtm_liqflgsw, rrtm_cldfr , rrtm_sw_taucld   ,&
+               rrtm_sw_ssacld  , rrtm_sw_asmcld, rrtm_sw_fsfcld, rrtm_cicewp  ,&
+               rrtm_cliqwp     , rrtm_reice   , rrtm_reliq , rrtm_sw_tauaer   ,&
+               rrtm_sw_ssaaer     , rrtm_sw_asmaer  , rrtm_sw_ecaer ,          &
+               rrtm_swuflx     , rrtm_swdflx  , rrtm_swhr  ,                   &
+               rrtm_swuflxc    , rrtm_swdflxc , rrtm_swhrc )
+  
+                DO k = nzb, nzt+1
+                   rad_sw_in(k,j,i)  = rrtm_swdflx(0,k)
+                   rad_sw_out(k,j,i) = rrtm_swuflx(0,k)
+                ENDDO
+             ENDIF
+
+!
+!--          Calculate surface net radiation
+             rad_net(j,i) = rad_sw_in(nzb,j,i) - rad_sw_out(nzb,j,i)           &
+                            + rad_lw_in(nzb,j,i) - rad_lw_out(nzb,j,i)
+
+          ENDDO
+       ENDDO
+
+       CALL exchange_horiz( rad_lw_in,  nbgp )
+       CALL exchange_horiz( rad_lw_out, nbgp )
+       CALL exchange_horiz( rad_sw_in,  nbgp )
+       CALL exchange_horiz( rad_sw_out, nbgp ) 
+       CALL exchange_horiz_2d( rad_net, nbgp )
+#endif
+
+    END SUBROUTINE radiation_rrtmg
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!-- Calculate the cosine of the zenith angle (variable is called zenith)
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_zenith
+
+       IMPLICIT NONE
+
+       REAL(wp) ::  declination,  & !: solar declination angle
+                    hour_angle      !: solar hour angle
 !
 !--    Calculate current day and time based on the initial values and simulation
 !--    time
-       day = day_init + FLOOR( (time_utc_init + time_since_reference_point)    &
-                               / 86400.0_wp )
+       day = day_init + INT(FLOOR( (time_utc_init + time_since_reference_point)    &
+                               / 86400.0_wp ), KIND=iwp)
        time_utc = MOD((time_utc_init + time_since_reference_point), 86400.0_wp)
 
